# todo.txt gnome-shell extension

This extension enables you to manage your [todo.txt](http://todotxt.com/ "Todo.txt homepage") file from gnome-shell.

##Supported features
* Adding new tasks
* Marking tasks as completed
* Deleting tasks (optionally with confirmation dialog)
* Show tasks grouped by projects or contexts
* Auto-archive of done tasks to done.txt
* Tasks are sorted by priority
* Done but not archived tasks are shown in italic text and include "archive" button
* Editing tasks
* Changes in todo.txt file via other ways are reflected in the extension
* Tasks can be shown in a specific style, based on the priority
* URLs in tasks can be opened in the default browser by clicking on them

##Known issues/missing features
* Task priority is not shown (but is considered for sorting)
* There is no possibility to show archived tasks
* ...

##Screenshots
Ungrouped mode, some tasks with projects and/or contexts, one task with high priority:

![Ungrouped todo.txt screenshot](http://lapino.be/media/todotxt.png "Todo.txt in ungrouped mode")

Grouped by projects, ungrouped tasks not in a separate group:

![Grouped todo.txt screenshot](http://lapino.be/media/todotxt_groups.png "Todo.txt in grouped mode")

Preferences:

![Preferences screenshot](http://lapino.be/media/todotxt_prefs.png "Todo.txt preferences")

##Installation
You can either use [the Gnome extensions web page](http://extensions.gnome.org) or do it yourself:

* Obtain the source code, either by cloning the repository or by downloading a tarball from ["Downloads/Tags" on the
  Bitbucket page](https://bitbucket.org/bartl/todo.txt-bart.libert.gmail.com/downloads#tag-downloads)
* Extract, copy or move the code to the directory ~/.local/share/gnome-shell/extensions/todo.txt@bart.libert.gmail.com
*Note: only this directory name will work, so pay attention*
* Execute the command glib-compile-schemas ~/.local/share/gnome-shell/extensions/todo.txt@bart.libert.gmail.com/schemas
*Note: if this command is not available, you should install it. In Debian, it's provided by the package libglib2.0-bin,
check your distro's documentation for the correct package for your case*
* Enable the extension with gnome-tweak-tool
* Configure the extension with gnome-shell-extension-preferences

##Credits
This extension uses [jsTodoTxt](https://github.com/jmhobbs/jsTodoTxt "jsTodoTxt homepage") by John Hobbs

Parts of this extension are based on:

* [Todo list](https://extensions.gnome.org/extension/162/todo-list/) by bsaleil
* [SettingsCenter](https://extensions.gnome.org/extension/341/settingscenter/) by Xes

Thank you!

##Licence
This code is released under GPLv2+

